function [Psi, Gamma] = compute_lmh(M, region, params)

R = sparse(1:M.n, 1:M.n, region);

[Psi, Gamma] = eigs(...
    @(x) sherman(x, M.W+params.mu*R, M.A*M.Phi, params.eta), ...
    M.n, ...
    M.A, ...
    params.k_local, ...
    'SM', ...
    struct('issym',1, 'isreal',1));
[Gamma, idx] = sort(diag(Gamma));
Psi = Psi(:,idx);

fprintf('%d localized manifold harmonics computed.\n', params.k_local)
